extends RigidBody2D

var id = "ball"
var count = 0

func kill(id):
	for player in core.players:
			if player != core.net.get_unique_id():
				rpc_id(player, "_free", id)
	_free(id)

func start(id):
	_start(id)
	for player in core.players:
		if player != core.net.get_unique_id():
			rpc_id(player, "_start", id)

remote func _start(id):
	if (name == id):
		count = 0
		$Timer.start()
		self.call_deferred("set_mode", 0)

remote func _free(id):
	if (name == id):
		queue_free()

remote func _sync(info):
	position = info[0]
	rotation = info[1]
	self.call_deferred("set_mode", info[2])

func _ready():
	self.mode = 1

func _process(delta):
	if (self.mode == 0):
		$BallShadow.rotation = -self.rotation

func _stop():
	if (core.net_mode == "host"):
		if (count < 10):
			count += 1
			$Timer.start()
			for player in core.players:
				if player != core.net.get_unique_id():
					rpc_id(player, "_sync", [position, rotation, 0])
		else:
			for player in core.players:
				if player != core.net.get_unique_id():
					rpc_id(player, "_sync", [position, rotation, 1])
			self.mode = 1
