extends Node2D

var noise = OpenSimplexNoise.new()
export var ball_load = preload("res://preload/ball.tscn")
var prev_point = -1
var main_point = -1
var offset = 0
var down = false

remotesync func add(data):
	for obj in data:
		var ball = ball_load.duplicate().instance()
		ball.position = obj[0]
		ball.name = obj[1]
		add_child(ball)

func _ready():
	self.rpc_config("add",1)
	var data = []
	if (core.net_mode == "host"):
		noise.seed = int(core.gen_seed)
		noise.octaves = 9
		noise.period = 1
		noise.persistence = 0.8
		var id = 0
		
		for x in range(0, 1920*core.window_scale/pow(2*pow(core.ball_radius,2),0.5)):
		#for x in range(15):
			var def_y = (noise.get_noise_1d(x/core.genscale)+1)/2
			#print(def_y)
			var raw_y = floor(def_y * core.ball_layers)
			var y = 0
			#print(pow(2*pow(core.ball_radius,2),0.5) * (int(abs(main_point-raw_y)) % 2)*2)
			y = 1079 - raw_y * pow(2*pow(core.ball_radius,2),0.5) - core.ball_min_layers*pow(2*pow(core.ball_radius,2),0.5) - core.ball_radius
			#print(str(def_y) + " " + str(raw_y) + " "+ str(y))
			#print(x*pow(2*pow(core.ball_radius,2),0.5))
			#$Line2D.add_point(Vector2(x*pow(2*pow(core.ball_radius,2),0.5) + core.ball_radius - floor(core.window_scale/2)*1920,y))
			if (main_point != raw_y and (int(abs(main_point-raw_y)) % 2) == 1):
				down = !down
				#y += pow(2*pow(core.ball_radius,2),0.5)
			if (prev_point != raw_y):
				if (main_point != raw_y and !down):
					pass
				else:
					down = false
					var ball = ball_load.duplicate().instance()
					ball.position.x = x*pow(2*pow(core.ball_radius,2),0.5) + core.ball_radius - floor(core.window_scale/2)*1920
					ball.position.y = y
					ball.name = str(id)
					add_child(ball)
					data.append([ball.position, ball.name])
					id += 1
					prev_point = raw_y
					offset = 1
			else:
				prev_point -=1
				down = true
			for bal in range(core.ball_layers + core.ball_min_layers):
			#for bal in range(core.ball_min_layers + abs(raw_y - core.ball_layers)):
				#print(y + pow(2*pow(core.ball_radius,2),0.5)*(bal*2) + pow(2*pow(core.ball_radius,2),0.5)*offset + pow(2*pow(core.ball_radius,2),0.5))
				if (y + pow(2*pow(core.ball_radius,2),0.5)*(bal*2) + pow(2*pow(core.ball_radius,2),0.5)*offset + pow(2*pow(core.ball_radius,2),0.5) + core.ball_radius < 1080 + core.ball_radius):
					var ball = ball_load.duplicate().instance()
					ball.position.x = x*pow(2*pow(core.ball_radius,2),0.5) + core.ball_radius - floor(core.window_scale/2)*1920
					ball.position.y = y + pow(2*pow(core.ball_radius,2),0.5)*(bal*2) + pow(2*pow(core.ball_radius,2),0.5)*offset + pow(2*pow(core.ball_radius,2),0.5)
					ball.name = str(id)
					add_child(ball)
					data.append([ball.position, ball.name])
					id += 1
				else: continue
			
			offset = 0
			main_point = raw_y
		
		for player in core.players:
			if player != core.net.get_unique_id():
				rpc_id(player, "add", data)
