extends Control

onready var ip_tree: Tree = $IP/Addresses
onready var MAXPLAYER: LineEdit = $Parameters/Max
onready var PORT: LineEdit = $Parameters/PORT
onready var HP: LineEdit = $Parameters/HP
onready var PRT: LineEdit = $Parameters/PRT
onready var RRT: LineEdit = $Parameters/RRT
onready var PD: LineEdit = $Parameters/PD
onready var RD: LineEdit = $Parameters/RD
onready var SEED: LineEdit = $Parameters/Seed

func _ready():
	ip_tree.create_item()
	ip_tree.set_hide_root(true)
	for address in IP.get_local_addresses():
		var item = ip_tree.create_item()
		item.set_selectable(0,false)
		item.set_text(0,address)


func _on_Max_text_entered(new_text):
	if (!new_text.is_valid_integer()):
		MAXPLAYER.text = "6"
	else: if (int(new_text) >= 7):
		MAXPLAYER.text = ""


func _host():
	if (MAXPLAYER.text.empty()): core.net_max_players = 6
	else: core.net_max_players = int(MAXPLAYER.text)
	if (PORT.text.empty()): core.server_port = 55555
	else: core.server_port = int(PORT.text)
	if (HP.text.empty()): core.net_max_hp = 100
	else: core.net_max_hp = int(HP.text)
	if (PRT.text.empty()): core.net_pistol_reload_time = 50
	else: core.net_pistol_reload_time = int(PRT.text)
	if (RRT.text.empty()): core.net_rocket_reload_time = 10
	else: core.net_rocket_reload_time = int(RRT.text)
	if (PD.text.empty()): core.net_pistol_damage = 5
	else: core.net_pistol_damage = int(PD.text)
	if (RD.text.empty()): core.net_rocket_damage = 50
	else: core.net_rocket_damage = int(RD.text)
	if (SEED.text.empty()): core.gen_seed = OS.get_unix_time()
	else: core.gen_seed = SEED.text
	
	core._hosting()
	core.players.append(core.net.get_unique_id())
	core.player_names.append(core.player_name)
	core.net_mode = "host"
	get_tree().change_scene("res://scenes/lobby_player.tscn")


func _on_PRT_text_changed(new_text):
	if (!new_text.is_valid_integer()): PORT.text = ""


func _on_HP_text_entered(new_text):
	if (!new_text.is_valid_integer()):
		HP.text = "100"
	else: if (int(new_text) > 5000):
		HP.text = "5000"


func _on_PRT_text_entered(new_text):
	if (!new_text.is_valid_integer()):
		PRT.text = "50"
	else: if (int(new_text) < 50):
		PRT.text = "50"


func _on_RRT_text_entered(new_text):
	if (!new_text.is_valid_integer()):
		RRT.text = "10"
	else: if (int(new_text) < 1):
		RRT.text = "1"


func _on_PD_text_entered(new_text):
	if (!new_text.is_valid_integer()):
		PD.text = "5"
	else: if (int(new_text) < 5):
		PD.text = "5"


func _on_RD_text_entered(new_text):
	if (!new_text.is_valid_integer()):
		RD.text = "20"
	else: if (int(new_text) < 5):
		RD.text = "5"


func _on_PORT_text_entered(new_text):
	if (!new_text.is_valid_integer()): PORT.text = ""
