extends Control


func _ready():
	$IP/IP.text = core.server_ip + ":" + str(core.server_port)
	$Info/Username.text = core.player_name
	$Info/Seed.text = "SEED: " + str(core.gen_seed)
	$Info/Players.text = "Players: " + str(len(core.players))
	$Info/MaxPlayers.text = "Maximum Players: " + str(core.net_max_players)
	$Players/Player_List.clear()
	$Players/Player_List.create_item()
	for player in core.player_names:
		var item = $Players/Player_List.create_item()
		item.set_text(0,player)
	
	
	
	if (core.net_mode == "host"):
		core.wait_time = 120
		$Starting/Timer.start(1)
	
	self.rpc_config("_new_time", 1)
	self.rpc_config("_start_game", 1)


func _time():
	core.wait_time -= 1
	$Starting/Text.text = "Starting in " + str(core.wait_time) + " seconds..."
	if (core.wait_time > 0):
		$Starting/Timer.start(1)
	else:
		if (len(core.players) == 1):
			get_tree().change_scene("res://scenes/menu.tscn")
		else:
			for player in core.players:
				rpc_id(player,"_start_game")
	_send_time()
	if (len(core.players)>1 and core.wait_time > 5):
		$Starting/SKIP.show()
	else:
		$Starting/SKIP.hide()

remotesync func _new_time(new_time):
	if (core.net_mode == "peer"):
		core.wait_time = new_time
		$Starting/Text.text = "Starting in " + str(core.wait_time) + " seconds..."
	_update(core.players, core.player_names)

func _update(new_players, new_player_names):
	$Info/Players.text = "Players: " + str(len(new_players))
	$Players/Player_List.clear()
	$Players/Player_List.create_item()
	for player in new_player_names:
		var item = $Players/Player_List.create_item()
		item.set_text(0,player)

func _send_time():
	for client in core.players:
		rpc_id(client, "_new_time", core.wait_time)

remotesync func _start_game():
	str(core.gen_seed).hash()
	get_tree().change_scene("res://scenes/game.tscn")


func _SKIP():
	core.wait_time = 5
	$Starting/SKIP.hide()
