extends Node2D

var player_preload = preload("res://preload/rigid_player.tscn")
var player_positions_list = [Vector2(960,300),Vector2(0,300),Vector2(1920,300),Vector2(-960,300),Vector2(2880,300),Vector2(-1920,300)]

func _ready():
	if (core.net != null):
		core.net.connect("peer_disconnected", self, "_remove_player")
	for player in range(len(core.players)):
		var client = player_preload.duplicate().instance()
		client.position = player_positions_list[player]
		client.set_name(str(core.players[player]))
		client.get_child(8).text = str(core.player_names[player])
		seed(client.name.hash())
		client.get_child(10).value = core.net_max_hp
		client.get_child(0).color = Color(randf(), randf(), randf())
		client.set_network_master(core.players[player])
		add_child(client)
	
	for player in $".".get_children():
		if (core.net != null):
			if (player.is_network_master()):
				player.set_collision_layer_bit(4, false)
				$"../camera".lock_player = player
				continue
			else:
				player.get_node("stat").hide()
		else:
			$"../camera".lock_player = $"1"
			continue


func _remove_player(id):
	for player in get_children():
		if (player.name == str(id)):
			player.queue_free()
			continue
	
	if (len(core.players) < 2):
		get_tree().set_network_peer(null)
		get_tree().change_scene("res://scenes/menu.tscn")
